# Class VulkanQueryPoolCreateInfo

java.lang.Object
com.io7m.jcoronado.api.VulkanQueryPoolCreateInfo

All Implemented Interfaces:
  `VulkanQueryPoolCreateInfoType`

public final class VulkanQueryPoolCreateInfo extends Object implements VulkanQueryPoolCreateInfoType
Structure specifying parameters of a newly created query pool.

See Also:
  - "VkQueryPoolCreateInfo"

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static final class`
  `VulkanQueryPoolCreateInfo.Builder`
  Builds instances of type `VulkanQueryPoolCreateInfo`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static VulkanQueryPoolCreateInfo.Builder`
  `builder()`
  Creates a builder for `VulkanQueryPoolCreateInfo`.
  `static VulkanQueryPoolCreateInfo`
  `copyOf(VulkanQueryPoolCreateInfoType instance)`
  Creates an immutable copy of a `VulkanQueryPoolCreateInfoType` value.
  `boolean`
  `equals(Object another)`
  This instance is equal to all instances of `VulkanQueryPoolCreateInfo` that have equal attribute values.
  `Set<VulkanQueryPoolCreateFlag>`
  `flags()`
  `int`
  `hashCode()`
  Computes a hash code from attributes: `flags`, `queryType`, `queryCount`, `pipelineStatistics`.
  `static VulkanQueryPoolCreateInfo`
  `of(Iterable<VulkanQueryPoolCreateFlag> flags, VulkanQueryKind queryType, int queryCount, Iterable<VulkanQueryPipelineStatisticFlag> pipelineStatistics)`
  Construct a new immutable `VulkanQueryPoolCreateInfo` instance.
  `static VulkanQueryPoolCreateInfo`
  `of(Set<VulkanQueryPoolCreateFlag> flags, VulkanQueryKind queryType, int queryCount, Set<VulkanQueryPipelineStatisticFlag> pipelineStatistics)`
  Construct a new immutable `VulkanQueryPoolCreateInfo` instance.
  `Set<VulkanQueryPipelineStatisticFlag>`
  `pipelineStatistics()`
  `int`
  `queryCount()`
  `VulkanQueryKind`
  `queryType()`
  `String`
  `toString()`
  Prints the immutable value `VulkanQueryPoolCreateInfo` with attribute values.
  `final VulkanQueryPoolCreateInfo`
  `withFlags(VulkanQueryPoolCreateFlag... elements)`
  Copy the current immutable object with elements that replace the content of `flags`.
  `final VulkanQueryPoolCreateInfo`
  `withFlags(Iterable<VulkanQueryPoolCreateFlag> elements)`
  Copy the current immutable object with elements that replace the content of `flags`.
  `final VulkanQueryPoolCreateInfo`
  `withPipelineStatistics(VulkanQueryPipelineStatisticFlag... elements)`
  Copy the current immutable object with elements that replace the content of `pipelineStatistics`.
  `final VulkanQueryPoolCreateInfo`
  `withPipelineStatistics(Iterable<VulkanQueryPipelineStatisticFlag> elements)`
  Copy the current immutable object with elements that replace the content of `pipelineStatistics`.
  `final VulkanQueryPoolCreateInfo`
  `withQueryCount(int value)`
  Copy the current immutable object by setting a value for the `queryCount` attribute.
  `final VulkanQueryPoolCreateInfo`
  `withQueryType(VulkanQueryKind value)`
  Copy the current immutable object by setting a value for the `queryType` attribute.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Method Details

  - ### flags

    public Set<VulkanQueryPoolCreateFlag> flags()
    Specified by:
      `flags` in interface `VulkanQueryPoolCreateInfoType`
    Returns:
      A set of flags specifying the creation of the pool

  - ### queryType

    public VulkanQueryKind queryType()
    Specified by:
      `queryType` in interface `VulkanQueryPoolCreateInfoType`
    Returns:
      A value specifying the type of queries managed by the pool.

  - ### queryCount

    public int queryCount()
    Specified by:
      `queryCount` in interface `VulkanQueryPoolCreateInfoType`
    Returns:
      The number of queries managed by the pool.

  - ### pipelineStatistics

    public Set<VulkanQueryPipelineStatisticFlag> pipelineStatistics()
    Specified by:
      `pipelineStatistics` in interface `VulkanQueryPoolCreateInfoType`
    Returns:
      A set of flags specifying which counters will be returned in queries on the new pool

  - ### withFlags

    public final VulkanQueryPoolCreateInfo withFlags(VulkanQueryPoolCreateFlag... elements)
    Copy the current immutable object with elements that replace the content of `flags`.
    Parameters:
      `elements` - The elements to set
    Returns:
      A modified copy of `this` object

  - ### withFlags

    public final VulkanQueryPoolCreateInfo withFlags(Iterable<VulkanQueryPoolCreateFlag> elements)
    Copy the current immutable object with elements that replace the content of `flags`. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `elements` - An iterable of flags elements to set
    Returns:
      A modified copy of `this` object

  - ### withQueryType

    public final VulkanQueryPoolCreateInfo withQueryType(VulkanQueryKind value)
    Copy the current immutable object by setting a value for the `queryType` attribute. A value equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for queryType
    Returns:
      A modified copy of the `this` object

  - ### withQueryCount

    public final VulkanQueryPoolCreateInfo withQueryCount(int value)
    Copy the current immutable object by setting a value for the `queryCount` attribute. A value equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for queryCount
    Returns:
      A modified copy of the `this` object

  - ### withPipelineStatistics

    public final VulkanQueryPoolCreateInfo withPipelineStatistics(VulkanQueryPipelineStatisticFlag... elements)
    Copy the current immutable object with elements that replace the content of `pipelineStatistics`.
    Parameters:
      `elements` - The elements to set
    Returns:
      A modified copy of `this` object

  - ### withPipelineStatistics

    public final VulkanQueryPoolCreateInfo withPipelineStatistics(Iterable<VulkanQueryPipelineStatisticFlag> elements)
    Copy the current immutable object with elements that replace the content of `pipelineStatistics`. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `elements` - An iterable of pipelineStatistics elements to set
    Returns:
      A modified copy of `this` object

  - ### equals

    public boolean equals(Object another)
    This instance is equal to all instances of `VulkanQueryPoolCreateInfo` that have equal attribute values.
    Overrides:
      `equals` in class `Object`
    Returns:
      `true` if `this` is equal to `another` instance

  - ### hashCode

    public int hashCode()
    Computes a hash code from attributes: `flags`, `queryType`, `queryCount`, `pipelineStatistics`.
    Overrides:
      `hashCode` in class `Object`
    Returns:
      hashCode value

  - ### toString

    public String toString()
    Prints the immutable value `VulkanQueryPoolCreateInfo` with attribute values.
    Overrides:
      `toString` in class `Object`
    Returns:
      A string representation of the value

  - ### of

    public static VulkanQueryPoolCreateInfo of(Set<VulkanQueryPoolCreateFlag> flags, VulkanQueryKind queryType, int queryCount, Set<VulkanQueryPipelineStatisticFlag> pipelineStatistics)
    Construct a new immutable `VulkanQueryPoolCreateInfo` instance.
    Parameters:
      `flags` - The value for the `flags` attribute
      `queryType` - The value for the `queryType` attribute
      `queryCount` - The value for the `queryCount` attribute
      `pipelineStatistics` - The value for the `pipelineStatistics` attribute
    Returns:
      An immutable VulkanQueryPoolCreateInfo instance

  - ### of

    public static VulkanQueryPoolCreateInfo of(Iterable<VulkanQueryPoolCreateFlag> flags, VulkanQueryKind queryType, int queryCount, Iterable<VulkanQueryPipelineStatisticFlag> pipelineStatistics)
    Construct a new immutable `VulkanQueryPoolCreateInfo` instance.
    Parameters:
      `flags` - The value for the `flags` attribute
      `queryType` - The value for the `queryType` attribute
      `queryCount` - The value for the `queryCount` attribute
      `pipelineStatistics` - The value for the `pipelineStatistics` attribute
    Returns:
      An immutable VulkanQueryPoolCreateInfo instance

  - ### copyOf

    public static VulkanQueryPoolCreateInfo copyOf(VulkanQueryPoolCreateInfoType instance)
    Creates an immutable copy of a `VulkanQueryPoolCreateInfoType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
    Parameters:
      `instance` - The instance to copy
    Returns:
      A copied immutable VulkanQueryPoolCreateInfo instance

  - ### builder

    public static VulkanQueryPoolCreateInfo.Builder builder()
    Creates a builder for `VulkanQueryPoolCreateInfo`.

         VulkanQueryPoolCreateInfo.builder()
            .addFlags|addAllFlags(com.io7m.jcoronado.api.VulkanQueryPoolCreateFlag) // flags elements
            .setQueryType(com.io7m.jcoronado.api.VulkanQueryKind) // required queryType
            .setQueryCount(int) // required queryCount
            .addPipelineStatistics|addAllPipelineStatistics(com.io7m.jcoronado.api.VulkanQueryPipelineStatisticFlag) // pipelineStatistics elements
            .build();

    Returns:
      A new VulkanQueryPoolCreateInfo builder